#include <stdio.h>
#include "constants.h"
#include <math.h>

int bndrel_slow(float theta0[], float u0[],
              float prs0[],
              float rho0[], float q0[],
              float up[][KX], float wp[][KX], float pp[][KX],
              float tht[][KX], float pprp[][KX], float dpdt[][KX],
              float wprm[][KX], float wprp[][KX], float dwdt[][KX])
{
  int i, k;
  float bdfunc[BDZ+1];

  bdfunc[0] = 0.0;
  bdfunc[1] = 0.0;
  for (i = 1; i < BDZ+1; i++)
    bdfunc[i] = bdfunc[i-1] + 1.0/((float)(BDZ-1));
  for (k = 0; k < KLEV; k++)
    for (i = 0; i < BDZ; i++)
      {
        tht[k][i] = tht[k][i] - (1.0-bdfunc[i])*tht[k][i];
        tht[k][KX-BDZ+i] = tht[k][KX-BDZ+i] - bdfunc[i]*tht[k][KX-BDZ+i];
      }
  return 0;
}
int bndrel_fast(float theta0[], float u0[],
              float prs0[],
              float rho0[], float q0[],
              float up[][KX], float wp[][KX], float pp[][KX])
{
  int i, k;
  float bdfunc[BDZ+1];

  bdfunc[0] = 0.0;
  bdfunc[1] = 0.0;
  for (i = 1; i < BDZ+1; i++)
    bdfunc[i] = bdfunc[i-1] + 1.0/((float)(BDZ-1));
  for (k = 0; k < KLEV; k++)
    for (i = 0; i < BDZ; i++)
      {
        up[k][i] = up[k][i] - (1.0-bdfunc[i])*(up[k][i]-u0[k]);
        up[k][KX-BDZ+i] = up[k][KX-BDZ+i] - bdfunc[i]*(up[k][KX-BDZ+i]-u0[k]);
        wp[k][i] = wp[k][i] - (1.0-bdfunc[i])*wp[k][i];
        wp[k][KX-BDZ+i] = wp[k][KX-BDZ+i] - bdfunc[i]*wp[k][KX-BDZ+i];
        pp[k][i] = pp[k][i] - (1.0-bdfunc[i])*pp[k][i];
        pp[k][KX-BDZ+i] = pp[k][KX-BDZ+i] - bdfunc[i]*pp[k][KX-BDZ+i];
      }
  return 0;
}
