#include <stdio.h>
#include "constants.h"
#include <math.h>

int fastterms(float theta0[], float u0[],
               float prs0[],
               float rho0[], float q0[],
               float uprm[][KX], float uprp[][KX], float dudt[][KX],
               float pprm[][KX], float pprp[][KX], float dpdt[][KX],
               float wprm[][KX], float wprp[][KX], float dwdt[][KX])
{
  int i, k, jt;
  float alpha;
  float dudtsm[KLEV][KX], dpdtsm[KLEV][KX];
  float dwdtsm[KLEV+1][KX];
  float div[KLEV][KX];

  int bndrel_fast(float [], float [],
               float [],
               float [], float [],
               float [][KX], float [][KX], float [][KX]);

  alpha = 0.002*DX*DX/SMDT;
  for (jt = 0; jt < NSMT; jt++)
    {
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX-1; i++)
          {
            dudtsm[k][i]=(pprm[k][i+1]-pprm[k][i])/(DX*rho0[k]);
          }
      for (k = 0; k < KLEV; k++)
        {
          dudtsm[k][KX-1]=(pprm[k][0]-pprm[k][KX-1])/(DX*rho0[k]);
        }
//      for (k = 0; k < KLEV; k++)
//        {
//          dudtsm[k][KX-1]=dudtsm[k][KX-2];
//        }
      for (k = 1; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            dwdtsm[k][i]=(pprm[k][i]-pprm[k-1][i])/(DZ*0.5*(rho0[k]+rho0[k-1]));
          }
      for (k = 0; k < KLEV; k++)
        for (i = 1; i < KX; i++)
          {
            div[k][i]=(uprm[k][i]-uprm[k][i-1])/DX+
              (wprm[k][i+1]-wprm[k][i])/DZ; //tundub justkui viga olevat
          }
      for (k = 0; k < KLEV; k++)
        {
          div[k][0]=div[k][1];
        }
//      for (k = 0; k < KLEV; k++)
//        for (i = 0; i < KX-1; i++)
//          {
//            dudtsm[k][i]=dudtsm[k][i]-alpha*
//              (div[k][i+1]-div[k][i])/DX;
//          }
//      for (k = 1; k < KLEV; k++)
//        for (i = 0; i < KX; i++)
//          {
//            dwdtsm[k][i]=dwdtsm[k][i]-alpha*
//              (div[k][i]-div[k-1][i])/DZ;
//          }
      for (i = 0; i < KX; i++)
        {
          dwdtsm[0][i]=0.0;
          dwdtsm[KLEV][i]=0.0;
        }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            uprp[k][i]=uprm[k][i]-SMDT*(dudtsm[k][i]-dudt[k][i]);
          }
      for (k = 0; k <= KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            wprp[k][i]=wprm[k][i]-SMDT*(dwdtsm[k][i]-dwdt[k][i]);
          }
      for (k = 0; k < KLEV; k++)
        for (i = 1; i < KX; i++)
          {
            dpdtsm[k][i]=GAMMA*prs0[k]*((uprp[k][i]-uprp[k][i-1])/DX
              + (wprp[k+1][i]-wprp[k][i])/DZ);
          }
//      for (k = 0; k < KLEV; k++)
//        {
//          dpdtsm[k][0]=dpdtsm[k][1];
//        }
      for (k = 0; k < KLEV; k++)
        {
          dpdtsm[k][0]=GAMMA*prs0[k]*((uprp[k][0]-uprp[k][KX-1])/DX
            + (wprp[k+1][0]-wprp[k][0])/DZ);
        }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            pprp[k][i]=pprm[k][i]-SMDT*(dpdtsm[k][i]-dpdt[k][i]);
          }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            uprm[k][i] = uprp[k][i];
            pprm[k][i] = pprp[k][i];
          }
      for (k = 0; k <= KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            wprm[k][i] = wprp[k][i];
          }
//      bndrel_fast(theta0, u0,
//                   prs0,
//                rho0, q0,
//             &uprm[0], &wprm[0], &pprm[0]);

    }
  return 0;
}
