#include <stdio.h>
#include "constants.h"
#include <math.h>

int initstate (float theta0[], float U0[],
               float prs0[],
               float rho0[], float q0[], float uprz[][KX], float wprz[][KX],
               float pprz[][KX], float thprz[][KX])

{
  int i, k, gaussian;
  float helpconst, aa, bb;
  float rad, radsqr, ht, xcntr, Tfluct_max, rr, ss;
  
  for (k = 0; k < KLEV; k++)
    {
      U0[k] = 0.0;
      q0[k] = 0.0;
      theta0[k] = 300.0;
    }
  prs0[0] = PZERO;
  helpconst = G/RGASD*pow(prs0[0],CAPPA);
  for (k = 1; k < KLEV; k++)
    {
      prs0[k] = prs0[k-1] - helpconst*pow(prs0[k-1],1.0-CAPPA)*DZ/theta0[k-1];
//      prs0[k] = PZERO;
    }
  helpconst = pow(prs0[0],CAPPA)/RGASD;
  for (k = 0; k < KLEV; k++)
    {
      rho0[k] = pow(prs0[k],1.0-CAPPA)*helpconst/theta0[k];
    }

  for (k = 0; k < KLEV; k++)
    for (i = 0; i < KX; i++)
      {
//        pprz[k][i] = 5.0/sqrt(1.0+(i-128)*(i-128)/50.);
        pprz[k][i] = 0.0;
//        uprz[k][i] = u0[k];
        uprz[k][i] = 0.0;
        wprz[k][i] = 0.0;
//        thprz[k][i] = 0.0;
//        thprz[k][i] = 5.0/sqrt(1.0+(i-128)*(i-128)/50.);
      }
  gaussian = 1; // 0 for circle
  rad = 150.0;
  radsqr = rad*rad;
  aa = 150.0;
  bb = 150.0;
  ht = 600.0;
  Tfluct_max = -0.5;
  xcntr = KX/2*DX;
  ss = 0.5;
  if (gaussian == 1)
    {
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            helpconst = (i*DX-xcntr)*(i*DX-xcntr)/(aa*aa)
              +(k*DZ-ht)*(k*DZ-ht)/(bb*bb);
            if (helpconst > 1.0)
              thprz[k][i] = Tfluct_max*exp(-(helpconst-1.0)*(helpconst-1.0)/(ss*ss));
            else
              thprz[k][i] = Tfluct_max;
          }
    }
  else 
    {
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            helpconst = (i*DX-xcntr)*(i*DX-xcntr)+(k*DZ-ht)*(k*DZ-ht);
            rr = sqrt(helpconst);
            if (helpconst < radsqr)
              thprz[k][i] = Tfluct_max*sin(sqrt(helpconst)/rad*M_PI/2.0+M_PI/2.0)
                *sin(sqrt(helpconst)/rad*M_PI/2.0+M_PI/2.0);
//        thprz[k][i] = 5.0/sqrt(1.0+(i-128)*(i-128)/50.);
      }
    }
  for (i = 0; i < KX; i++)
    {
      wprz[KLEV][i] = 0.0;
    }
  return 0;
}
