#include <stdio.h>
#include "constants.h"
#include <math.h>

int integrator (int nstop, float theta0[], float u0[],
               float prs0[],
               float rho0[], float q0[], float uprz[][KX], float wprz[][KX],
               float pprz[][KX], float thprz[][KX])
{
  int i, k, jt;
  float twodt, helpconst;
  float uprm[KLEV][KX], uprp[KLEV][KX];
  float wprm[KLEV+1][KX], wprp[KLEV+1][KX];
  float pprm[KLEV][KX], pprp[KLEV][KX];
  float thprm[KLEV][KX], thprp[KLEV][KX];
  float dudt[KLEV][KX], dpdt[KLEV][KX], dthdt[KLEV][KX];
  float dwdt[KLEV+1][KX];

  int tendencies (float [], float [], float [], float [], float [],
                  float [][KX], float [][KX], float [][KX], float [][KX],
                  float [][KX], float [][KX], float [][KX], float [][KX]);
  int fastterms(float [], float [], float [], float [], float [],
                  float [][KX], float [][KX], float [][KX],
                  float [][KX], float [][KX], float [][KX],
                  float [][KX], float [][KX], float [][KX]);
  int bndrel_slow(float [], float [],
             float [],
             float [], float [],
             float [][KX], float [][KX], float [][KX],
             float [][KX], float [][KX], float [][KX],
             float [][KX], float [][KX], float [][KX]);

  twodt = NSMT*SMDT;
  for (k = 0; k < KLEV; k++)
    for (i = 0; i < KX; i++)
      {
        uprm[k][i] = uprz[k][i]; 
        wprm[k][i] = wprz[k][i]; 
        pprm[k][i] = pprz[k][i]; 
        thprm[k][i] = thprz[k][i]; 
      }
  for (i = 0; i < KX; i++)
    {
      wprm[KLEV][i] = wprz[KLEV][i];
    }
//  tendencies(theta0, u0, prs0, rho0, q0, uprz, &dudt[0], pprz, &dpdt[0]);
//  fastterms(theta0, u0, prs0, rho0, q0, uprm, &uprp[0], dudt,
//            pprm, &pprp[0], dpdt);
//  for (k = 0; k < KLEV; k++)
//    for (i = 0; i < KX; i++)
//      {
//        uprz[k][i] = uprm[k][i] + 0.5 * DT * dudt[k][i]; 
//        pprz[k][i] = pprm[k][i] + 0.5 * DT * dpdt[k][i]; 
//      }
//  for (k = 0; k < KLEV; k++)
//    for (i = 0; i < KX; i++)
//      {
//        uprz[k][i] = uprm[k][i] + DT * dudt[k][i]; 
//        pprz[k][i] = pprm[k][i] + DT * dpdt[k][i]; 
//      }
//  tendencies(theta0, u0, prs0, rho0, q0, uprz, &dudt[0], pprz, &dpdt[0]);
//  fastterms(theta0, u0, prs0, rho0, q0, uprm, &uprp[0], dudt,
//            pprm, &pprp[0], dpdt);
  for (jt = 0; jt < nstop; jt++)
    {
      tendencies(theta0, u0, prs0, rho0, q0, uprz, &dudt[0], pprz, &dpdt[0],
                 thprz, &dthdt[0],  wprz, &dwdt[0]);
      fastterms(theta0, u0, prs0, rho0, q0, uprm, &uprp[0], dudt,
                pprm, &pprp[0], dpdt, wprm, &wprp[0], dwdt);
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            thprp[k][i] = thprm[k][i] + twodt * dthdt[k][i];
          }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            uprz[k][i] = uprz[k][i]+ROBALPHA*
              (uprm[k][i]-2.0*uprz[k][i]+uprp[k][i]);
            pprz[k][i] = pprz[k][i]+ROBALPHA*
              (pprm[k][i]-2.0*pprz[k][i]+pprp[k][i]);
            thprz[k][i] = thprz[k][i]+ROBALPHA*
              (thprm[k][i]-2.0*thprz[k][i]+thprp[k][i]);
          }
      for (k = 0; k <= KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            wprz[k][i] = wprz[k][i]+ROBALPHA*
              (wprm[k][i]-2.0*wprz[k][i]+wprp[k][i]);
          }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            uprm[k][i] = uprz[k][i];
            pprm[k][i] = pprz[k][i];
            thprm[k][i] = thprz[k][i];
          }
      for (k = 0; k <= KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            wprm[k][i] = wprz[k][i];
          }
      for (k = 0; k < KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            uprz[k][i] = uprp[k][i];
            pprz[k][i] = pprp[k][i];
            thprz[k][i] = thprp[k][i];
          }
      for (k = 0; k <= KLEV; k++)
        for (i = 0; i < KX; i++)
          {
            wprz[k][i] = wprp[k][i];
          }
//      bndrel_slow(theta0, u0,
//             prs0,
//             rho0, q0,
//             &uprz[0], &wprz[0], &pprz[0],
//             &thprz[0], pprp, dpdt,
//             wprm, wprp, dwdt);
    }

//  for (k = 0; k < KLEV; k++)
//    {
//      for (i = 0; i < KX; i++)
//        {
//          printf("%f\n", thprz[k][i]);
//        }
//      printf("\n");
//    }
  return 0;
}
