#include <stdio.h>
#include "constants.h"
#include <math.h>

int tendencies (float theta0[], float u0[], float prs0[],
               float rho0[], float q0[], float uprz[][KX], float dudt[][KX],
               float pprz[][KX], float dpdt[][KX],
               float thprz[][KX], float dthdt[][KX],
               float wprz[][KX], float dwdt[][KX])
{
  int i, k;
  float helpconst, r2dx, dxby3;

  dxby3 = -1.0/(3.0*DX);
  r2dx = -0.5/DX;
//  for (k = 1; k < KLEV-1; k++)
//    for (i = 2; i < KX-2; i++)
//      {
//        dudt[k][i] = 
//          dxby3*uprz[k][i]*(2.0*(uprz[k][i+1]-uprz[k][i-1])
//          -0.25*(uprz[k][i+2]-uprz[k][i-2]))
//          -0.25*((wprz[k+1][i]+wprz[k+1][i+1])*(uprz[k+1][i] - uprz[k][i])
//          +(wprz[k][i]+wprz[k][i+1])*(uprz[k][i] - uprz[k-1][i]))/DZ;
//        dwdt[k][i] = 
//          dxby3*(2.0*(wprz[k][i+1]-wprz[k][i-1])
//          -0.25*(wprz[k][i+2]-wprz[k][i-2]))
//          *0.25*(uprz[k-1][i]+uprz[k-1][i-1]+uprz[k][i]+uprz[k][i-1])
//          -0.5*wprz[k][i]*(wprz[k+1][i] - wprz[k-1][i])/DZ
//          + G*((thprz[k-1][i]+thprz[k][i])/(theta0[k-1]+theta0[k])
//          -(pprz[k-1][i]+pprz[k][i])/(GAMMA*(prs0[k-1]+prs0[k])));
//        dpdt[k][i] = 
//          dxby3*(2.0*(pprz[k][i+1]-pprz[k][i-1])
//          -0.25*(pprz[k][i+2]-pprz[k][i-2]))*
//          0.5*(uprz[k][i]+uprz[k][i-1])
//          -0.5*(wprz[k+1][i]*(pprz[k+1][i]-pprz[k][i])
//          +wprz[k][i]*(pprz[k][i]-pprz[k-1][i]))/DZ
//          +G*rho0[k]*0.5*(wprz[k][i]+wprz[k+1][i]);
//        dthdt[k][i] = 
//          dxby3*(2.0*(thprz[k][i+1]-thprz[k][i-1])
//          -0.25*(thprz[k][i+2]-thprz[k][i-2]))*
//          0.5*(uprz[k][i]+uprz[k][i-1])
//          -0.5*(wprz[k+1][i]*(thprz[k+1][i]-thprz[k][i])
//	  +wprz[k][i]*(thprz[k][i]-thprz[k-1][i]))/DZ;
//      }
  for (k = 1; k < KLEV-1; k++)
    for (i = 1; i < KX-1; i++)
      {
        dudt[k][i] = 
          -0.25*((uprz[k][i+1]+uprz[k][i])*(uprz[k][i+1]+uprz[k][i])
          -(uprz[k][i]+uprz[k][i-1])*(uprz[k][i]+uprz[k][i-1]))/DX
          +0.5*uprz[k][i]*(uprz[k][i+1] - uprz[k][i-1])/DX
          -0.5*((uprz[k+1][i]+uprz[k][i])*wprz[k+1][i]
          -(uprz[k][i]+uprz[k-1][i])*wprz[k][i])/DZ
          +uprz[k][i]*(wprz[k+1][i] - wprz[k][i])/DZ;
//        dudt[k][i] = 
//          -0.5*uprz[k][i]*(uprz[k][i+1] - uprz[k][i-1])/DX
//          -0.25*((wprz[k+1][i]+wprz[k+1][i+1])*(uprz[k+1][i] - uprz[k][i])
//          +(wprz[k][i]+wprz[k][i+1])*(uprz[k][i] - uprz[k-1][i]))/DZ;
//        dwdt[k][i] = -0.5*(wprz[k][i+1]-wprz[k][i-1])/DX
//          *0.25*(uprz[k-1][i]+uprz[k-1][i-1]+uprz[k][i]+uprz[k][i-1])
//          -0.5*wprz[k][i]*(wprz[k+1][i] - wprz[k-1][i])/DZ
//          + G*((thprz[k-1][i]+thprz[k][i])/(theta0[k-1]+theta0[k])
//          -(pprz[k-1][i]+pprz[k][i])/(GAMMA*(prs0[k-1]+prs0[k])));
        dwdt[k][i] = -0.5*((wprz[k][i+1]+wprz[k][i])*uprz[k][i]
          -(wprz[k][i]+wprz[k][i-1])*uprz[k][i-1])/DX
          +wprz[k][i]*(uprz[k][i] - uprz[k][i-1])/DX
          -0.25*((wprz[k+1][i]+wprz[k][i])*(wprz[k+1][i]+wprz[k][i])
          -(wprz[k][i]+wprz[k-1][i])*(wprz[k][i]+wprz[k-1][i]))/DZ  
          +0.25*((wprz[k-1][i]+wprz[k][i])*(wprz[k][i] - wprz[k-1][i])
          +(wprz[k+1][i]+wprz[k][i])*(wprz[k+1][i] - wprz[k][i]))/DZ
          + G*((thprz[k-1][i]+thprz[k][i])/(theta0[k-1]+theta0[k])
          -(pprz[k-1][i]+pprz[k][i])/(GAMMA*(prs0[k-1]+prs0[k])));
        dpdt[k][i] = 
          -0.25*(uprz[k][i]+uprz[k][i-1])*(pprz[k][i+1]-pprz[k][i-1])/DX
          -0.5*(wprz[k+1][i]*(pprz[k+1][i]-pprz[k][i])
          +wprz[k][i]*(pprz[k][i]-pprz[k-1][i]))/DZ
          +G*rho0[k]*0.5*(wprz[k][i]+wprz[k+1][i]);
//        dpdt[k][i] = -0.5*(uprz[k][i]*(pprz[k][i+1]+pprz[k][i])
//          -uprz[k][i-1]*(pprz[k][i]+pprz[k][i-1]))/DX
//          +pprz[k][i]*(uprz[k][i] - uprz[k][i-1])/DX
//          -0.5*(wprz[k+1][i]*(pprz[k+1][i]+pprz[k][i])
//          -wprz[k][i]*(pprz[k][i]+pprz[k-1][i]))/DZ
//          +pprz[k][i]*(wprz[k+1][i] - wprz[k][i])/DZ
//          +G*rho0[k]*0.5*(wprz[k][i]+wprz[k+1][i]);
        dthdt[k][i] = -0.5*(uprz[k][i]*(thprz[k][i+1]+thprz[k][i])
          -uprz[k][i-1]*(thprz[k][i]+thprz[k][i-1]))/DX
          +thprz[k][i]*(uprz[k][i] - uprz[k][i-1])/DX
          -0.5*(wprz[k+1][i]*(thprz[k+1][i]+thprz[k][i])
          -wprz[k][i]*(thprz[k][i]+thprz[k-1][i]))/DZ
          +thprz[k][i]*(wprz[k+1][i] - wprz[k][i])/DZ;
//        dthdt[k][i] = 
//          -0.25*(uprz[k][i]+uprz[k][i-1])*(thprz[k][i+1]-thprz[k][i-1])/DX
//          -0.5*(wprz[k+1][i]*(thprz[k+1][i]-thprz[k][i])
//          +wprz[k][i]*(thprz[k][i]-thprz[k-1][i]))/DZ;
      }
  for (k = 1; k < KLEV-1; k++)
    {
      dudt[k][0] = 
        -0.25*((uprz[k][1]+uprz[k][0])*(uprz[k][1]+uprz[k][0])
        -(uprz[k][0]+uprz[k][KX-1])*(uprz[k][0]+uprz[k][KX-1]))/DX
        +0.5*uprz[k][0]*(uprz[k][1] - uprz[k][KX-1])/DX
        -0.5*((uprz[k+1][0]+uprz[k][0])*wprz[k+1][0]
        -(uprz[k][0]+uprz[k-1][0])*wprz[k][0])/DZ
        +uprz[k][0]*(wprz[k+1][0] - wprz[k][0])/DZ;
      dwdt[k][0] = -0.5*((wprz[k][1]+wprz[k][0])*uprz[k][0]
        -(wprz[k][0]+wprz[k][KX-1])*uprz[k][KX-1])/DX
        +wprz[k][0]*(uprz[k][0] - uprz[k][KX-1])/DX
        -0.25*((wprz[k+1][0]+wprz[k][0])*(wprz[k+1][0]+wprz[k][0])
        -(wprz[k][0]+wprz[k-1][0])*(wprz[k][0]+wprz[k-1][0]))/DZ  
        +0.25*((wprz[k-1][0]+wprz[k][0])*(wprz[k][0] - wprz[k-1][0])
        +(wprz[k+1][0]+wprz[k][0])*(wprz[k+1][0] - wprz[k][0]))/DZ
        + G*((thprz[k-1][0]+thprz[k][0])/(theta0[k-1]+theta0[k])
        -(pprz[k-1][0]+pprz[k][0])/(GAMMA*(prs0[k-1]+prs0[k])));
      dpdt[k][0] = 
        -0.25*(uprz[k][0]+uprz[k][KX-1])*(pprz[k][1]-pprz[k][KX-1])/DX
        -0.5*(wprz[k+1][0]*(pprz[k+1][0]-pprz[k][0])
        +wprz[k][0]*(pprz[k][0]-pprz[k-1][0]))/DZ
        +G*rho0[k]*0.5*(wprz[k][0]+wprz[k+1][0]);
      dthdt[k][0] = -0.5*(uprz[k][0]*(thprz[k][1]+thprz[k][0])
        -uprz[k][KX-1]*(thprz[k][0]+thprz[k][KX-1]))/DX
        +thprz[k][0]*(uprz[k][0] - uprz[k][KX-1])/DX
        -0.5*(wprz[k+1][0]*(thprz[k+1][0]+thprz[k][0])
        -wprz[k][0]*(thprz[k][0]+thprz[k-1][0]))/DZ
        +thprz[k][0]*(wprz[k+1][0] - wprz[k][0])/DZ;
      dudt[k][KX-1] = 
        -0.25*((uprz[k][0]+uprz[k][KX-1])*(uprz[k][0]+uprz[k][KX-1])
        -(uprz[k][KX-1]+uprz[k][KX-2])*(uprz[k][KX-1]+uprz[k][KX-2]))/DX
        +0.5*uprz[k][KX-1]*(uprz[k][0] - uprz[k][KX-2])/DX
        -0.5*((uprz[k+1][KX-1]+uprz[k][KX-1])*wprz[k+1][KX-1]
        -(uprz[k][KX-1]+uprz[k-1][KX-1])*wprz[k][KX-1])/DZ
        +uprz[k][KX-1]*(wprz[k+1][KX-1] - wprz[k][KX-1])/DZ;
      dwdt[k][KX-1] = -0.5*((wprz[k][0]+wprz[k][KX-1])*uprz[k][KX-1]
        -(wprz[k][KX-1]+wprz[k][KX-2])*uprz[k][KX-2])/DX
        +wprz[k][KX-1]*(uprz[k][KX-1] - uprz[k][KX-2])/DX
        -0.25*((wprz[k+1][KX-1]+wprz[k][KX-1])*(wprz[k+1][KX-1]+wprz[k][KX-1])
        -(wprz[k][KX-1]+wprz[k-1][KX-1])*(wprz[k][KX-1]+wprz[k-1][KX-1]))/DZ  
        +0.25*((wprz[k-1][KX-1]+wprz[k][KX-1])*(wprz[k][KX-1] -
wprz[k-1][KX-1])
        +(wprz[k+1][KX-1]+wprz[k][KX-1])*(wprz[k+1][KX-1] - wprz[k][KX-1]))/DZ
        + G*((thprz[k-1][KX-1]+thprz[k][KX-1])/(theta0[k-1]+theta0[k])
        -(pprz[k-1][KX-1]+pprz[k][KX-1])/(GAMMA*(prs0[k-1]+prs0[k])));
      dpdt[k][KX-1] = 
        -0.25*(uprz[k][KX-1]+uprz[k][KX-2])*(pprz[k][0]-pprz[k][KX-2])/DX
        -0.5*(wprz[k+1][KX-1]*(pprz[k+1][KX-1]-pprz[k][KX-1])
        +wprz[k][KX-1]*(pprz[k][KX-1]-pprz[k-1][KX-1]))/DZ
        +G*rho0[k]*0.5*(wprz[k][KX-1]+wprz[k+1][KX-1]);
      dthdt[k][KX-1] = -0.5*(uprz[k][KX-1]*(thprz[k][0]+thprz[k][KX-1])
        -uprz[k][KX-2]*(thprz[k][KX-1]+thprz[k][KX-2]))/DX
        +thprz[k][KX-1]*(uprz[k][KX-1] - uprz[k][KX-2])/DX
        -0.5*(wprz[k+1][KX-1]*(thprz[k+1][KX-1]+thprz[k][KX-1])
        -wprz[k][KX-1]*(thprz[k][KX-1]+thprz[k-1][KX-1]))/DZ
        +thprz[k][KX-1]*(wprz[k+1][KX-1] - wprz[k][KX-1])/DZ;
    }
//    dudt[0][0] = 
//      -0.25*((uprz[0][1]+uprz[0][0])*(uprz[0][1]+uprz[0][0])
//      -(uprz[0][0]+uprz[0][KX-1])*(uprz[0][0]+uprz[0][KX-1]))/DX
//      +0.5*uprz[0][0]*(uprz[0][1] - uprz[0][KX-1])/DX
//      -0.5*((uprz[1][0]+uprz[0][0])*wprz[1][0])/DZ
//      +uprz[0][0]*(wprz[1][0])/DZ;
//    dudt[KLEV-1][0] = 
//      -0.25*((uprz[KLEV-1][1]+uprz[KLEV-1][0])*(uprz[KLEV-1][1]+uprz[KLEV-1][0])
//      -(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])*(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1]))/DX
//      +0.5*uprz[KLEV-1][0]*(uprz[KLEV-1][1] - uprz[KLEV-1][KX-1])/DX
//      -0.5*(
//      -(uprz[KLEV-1][0]+uprz[KLEV-2][0])*wprz[KLEV-1][0])/DZ
//      +uprz[KLEV-1][0]*( - wprz[KLEV-1][0])/DZ;
//      dudt[0][KX-1] = 
//        -0.25*((uprz[0][0]+uprz[0][KX-1])*(uprz[0][0]+uprz[0][KX-1])
//        -(uprz[0][KX-1]+uprz[0][KX-2])*(uprz[0][KX-1]+uprz[0][KX-2]))/DX
//        +0.5*uprz[0][KX-1]*(uprz[0][0] - uprz[0][KX-2])/DX
//        -0.5*((uprz[k+1][KX-1]+uprz[0][KX-1])*wprz[1][KX-1])/DZ
//        +uprz[0][KX-1]*(wprz[1][KX-1])/DZ;
//      dudt[KLEV-1][KX-1] = 
//        -0.25*((uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])*(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])
//        -(uprz[KLEV-1][KX-1]+uprz[KLEV-1][KX-2])*(uprz[KLEV-1][KX-1]+uprz[KLEV-1][KX-2]))/DX
//        +0.5*uprz[KLEV-1][KX-1]*(uprz[KLEV-1][0] - uprz[KLEV-1][KX-2])/DX
//        -0.5*( -(uprz[KLEV-1][KX-1]+uprz[KLEV-2][KX-1])*wprz[k][KX-1])/DZ
//        +uprz[KLEV-1][KX-1]*( - wprz[KLEV-1][KX-1])/DZ;
//      dpdt[0][0] = 
//        -0.25*(uprz[0][0]+uprz[0][KX-1])*(pprz[0][1]-pprz[0][KX-1])/DX
//        -0.5*(wprz[1][0]*(pprz[1][0]-pprz[0][0]))/DZ
//        +G*rho0[0]*0.5*(wprz[1][0]);
//      dpdt[KLEV-1][0] = 
//        -0.25*(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])*(pprz[KLEV-1][1]-pprz[KLEV-1][KX-1])/DX
//        -0.5*(wprz[KLEV-1][0]*(pprz[KLEV-1][0]-pprz[KLEV-2][0]))/DZ
//        +G*rho0[KLEV-1]*0.5*(wprz[KLEV-1][0]);
//      dpdt[0][KX-1] = 
//        -0.25*(uprz[0][KX-1]+uprz[0][KX-2])*(pprz[0][0]-pprz[0][KX-2])/DX
//        -0.5*(wprz[1][KX-1]*(pprz[1][KX-1]-pprz[0][KX-1]))/DZ
//        +G*rho0[0]*0.5*(wprz[1][KX-1]);
//      dpdt[KLEV-1][KX-1] = 
//        -0.25*(uprz[KLEV-1][KX-1]+uprz[KLEV-1][KX-2])*(pprz[KLEV-1][0]-pprz[KLEV-1][KX-2])/DX
//        -0.5*(wprz[KLEV-1][KX-1]*(pprz[KLEV-1][KX-1]-pprz[KLEV-2][KX-1]))/DZ
//        +G*rho0[KLEV-1]*0.5*(wprz[KLEV-1][KX-1]);
//      dthdt[0][0] = -0.5*(uprz[0][0]*(thprz[0][1]+thprz[0][0])
//        -uprz[0][KX-1]*(thprz[0][0]+thprz[0][KX-1]))/DX
//        +thprz[0][0]*(uprz[0][0] - uprz[0][KX-1])/DX
//        -0.5*(wprz[1][0]*(thprz[1][0]+thprz[0][0]))/DZ
//        +thprz[0][0]*(wprz[1][0])/DZ;
//  for (k = 1; k < KLEV-1; k++)
//    {
//      dudt[k][1] = 
//        r2dx*uprz[k][1]*(uprz[k][1] - uprz[k][0])
//        -0.25*((wprz[k+1][1]+wprz[k+1][2])*(uprz[k+1][1] - uprz[k][1])
//        +(wprz[k][1]+wprz[k][2])*(uprz[k][1] - uprz[k-1][1]))/DZ;
//      dudt[k][KX-2] = 
//        r2dx*uprz[k][KX-2]*(uprz[k][KX-1] - uprz[k][KX-3])
//        -0.25*((wprz[k+1][KX-2]+wprz[k+1][KX-1])*(uprz[k+1][KX-2]-uprz[k][KX-2])
//        +(wprz[k][KX-2]+wprz[k][KX-1])*(uprz[k][KX-2] - uprz[k-1][KX-2]))/DZ;
//      dpdt[k][1] = 
//        -0.25*(uprz[k][1]+uprz[k][0])*(pprz[k][2]-pprz[k][0])/DX
//        -0.5*(wprz[k+1][1]*(pprz[k+1][1]-pprz[k][1])
//        +wprz[k][1]*(pprz[k][1]-pprz[k-1][1]))/DZ
//        +G*rho0[k]*0.5*(wprz[k][1]+wprz[k+1][1]);
//      dpdt[k][KX-2] = 
//        -0.25*(uprz[k][KX-2]+uprz[k][KX-3])*(pprz[k][KX-1]-pprz[k][KX-3])/DX
//        -0.5*(wprz[k+1][KX-2]*(pprz[k+1][KX-2]-pprz[k][KX-2])
//        +wprz[k][KX-2]*(pprz[k][KX-2]-pprz[k-1][KX-2]))/DZ
//        +G*rho0[k]*0.5*(wprz[k][KX-2]+wprz[k+1][KX-2]);
//      dthdt[k][1] = 
//        0.5*r2dx*(uprz[k][1]+uprz[k][0])*(thprz[k][2]-thprz[k][0])
//        -0.5*(wprz[k+1][1]*(thprz[k+1][1]-thprz[k][1])
//        +wprz[k][1]*(thprz[k][1]-thprz[k-1][1]))/DZ;
//      dthdt[k][KX-2] = 
//        0.5*r2dx*(uprz[k][KX-2]+uprz[k][KX-3])*(thprz[k][KX-1]-thprz[k][KX-3])
//        -0.5*(wprz[k+1][KX-2]*(thprz[k+1][KX-2]-thprz[k][KX-2])
//        +wprz[k][KX-2]*(thprz[k][KX-2]-thprz[k-1][KX-2]))/DZ;
//      dwdt[k][1] = -0.5*(wprz[k][2]-wprz[k][0])/DX
//        *0.25*(uprz[k-1][1]+uprz[k-1][0]+uprz[k][1]+uprz[k][0])
//        -0.5*wprz[k][1]*(wprz[k+1][1] - wprz[k-1][1])/DZ
//        + G*((thprz[k-1][1]+thprz[k][1])/(theta0[k-1]+theta0[k])
//        -(pprz[k-1][1]+pprz[k][1])/(GAMMA*(prs0[k-1]+prs0[k])));
//      dwdt[k][KX-2] = -0.5*(wprz[k][KX-1]-wprz[k][KX-3])/DX
//        *0.25*(uprz[k-1][KX-2]+uprz[k-1][KX-3]+uprz[k][KX-2]+uprz[k][KX-3])
//        -0.5*wprz[k][KX-2]*(wprz[k+1][KX-2] - wprz[k-1][KX-2])/DZ
//        + G*((thprz[k-1][KX-2]+thprz[k][KX-2])/(theta0[k-1]+theta0[k])
//        -(pprz[k-1][KX-2]+pprz[k][KX-2])/(GAMMA*(prs0[k-1]+prs0[k])));
//    }
//  for (i = 2; i < KX-2; i++)
//    {
//        dudt[0][i] = 
//          dxby3*uprz[0][i]*(2.0*(uprz[0][i+1]-uprz[0][i-1])
//          -0.25*(uprz[0][i+2]-uprz[0][i-2]))
//          -0.25*(wprz[1][i]+wprz[1][i+1])*(uprz[1][i] - uprz[0][i])/DZ;
//        dudt[KLEV-1][i] = 
//          dxby3*uprz[KLEV-1][i]*(2.0*(uprz[KLEV-1][i+1]-uprz[KLEV-1][i-1])
//          -0.25*(uprz[KLEV-1][i+2]-uprz[KLEV-1][i-2]))
//          -0.25*(wprz[KLEV-1][i]+wprz[KLEV-1][i+1])
//	  *(uprz[KLEV-1][i] - uprz[KLEV-2][i])/DZ;
//        dpdt[0][i] = 
//          dxby3*(2.0*(pprz[0][i+1]-pprz[0][i-1])
//          -0.25*(pprz[0][i+2]-pprz[0][i-2]))*
//          0.5*(uprz[0][i]+uprz[0][i-1])
//          -0.5*wprz[1][i]*(pprz[k+1][i]-pprz[0][i])/DZ
//          +G*rho0[0]*0.5*wprz[1][i];
//        dpdt[KLEV-1][i] = 
//          dxby3*(2.0*(pprz[KLEV-1][i+1]-pprz[KLEV-1][i-1])
//          -0.25*(pprz[KLEV-1][i+2]-pprz[KLEV-1][i-2]))*
//          0.5*(uprz[KLEV-1][i]+uprz[KLEV-1][i-1])
//          -0.5*wprz[KLEV-1][i]*(pprz[KLEV-1][i]-pprz[KLEV-2][i])/DZ
//          +G*rho0[KLEV-1]*0.5*wprz[KLEV-1][i];
//        dthdt[0][i] = 
//          dxby3*(2.0*(thprz[0][i+1]-thprz[0][i-1])
//          -0.25*(thprz[0][i+2]-thprz[0][i-2]))*
//          0.5*(uprz[0][i]+uprz[0][i-1])
//          -0.5*wprz[1][i]*(thprz[k+1][i]-thprz[0][i])/DZ;
//        dthdt[KLEV-1][i] = 
//          dxby3*(2.0*(thprz[KLEV-1][i+1]-thprz[KLEV-1][i-1])
//          -0.25*(thprz[KLEV-1][i+2]-thprz[KLEV-1][i-2]))*
//          0.5*(uprz[KLEV-1][i]+uprz[KLEV-1][i-1])
//          -0.5*wprz[KLEV-1][i]*(thprz[KLEV-1][i]-thprz[KLEV-2][i])/DZ;
//    }
//        dudt[0][1] = 
//          -0.5*uprz[0][1]*(uprz[0][1] - uprz[0][0])/DX
//          -0.25*((wprz[1][1]+wprz[1][2])*(uprz[1][1] - uprz[0][1])
//          )/DZ;
//        dudt[0][KX-2] = 
//          -0.5*uprz[0][KX-2]*(uprz[0][KX-1] - uprz[0][KX-3])/DX
//          -0.25*((wprz[1][KX-2]+wprz[1][KX-1])*(uprz[1][KX-2] - uprz[0][KX-2])
//          )/DZ;
//        dudt[KLEV-1][1] = 
//          -0.5*uprz[KLEV-1][1]*(uprz[KLEV-1][1] - uprz[KLEV-1][0])/DX
//          -0.25*(
//          (wprz[KLEV-1][1]+wprz[KLEV-1][2])*(uprz[KLEV-1][1] - uprz[KLEV-2][1]))/DZ;
//        dudt[KLEV-1][KX-2] = 
//          -0.5*uprz[KLEV-1][KX-2]*(uprz[KLEV-1][KX-1] - uprz[KLEV-1][KX-3])/DX
//          -0.25*(
//          (wprz[KLEV-1][KX-2]+wprz[KLEV-1][KX-1])*(uprz[KLEV-1][KX-2] - uprz[KLEV-2][KX-2]))/DZ;
//        dpdt[0][1] = 
//          -0.25*(uprz[0][1]+uprz[0][0])*(pprz[0][2]-pprz[0][0])/DX
//          -0.5*(wprz[1][1]*(pprz[1][1]-pprz[0][1]))/DZ
//          +G*rho0[0]*0.5*wprz[1][1];
//        dpdt[0][KX-2] = 
//          -0.25*(uprz[0][KX-2]+uprz[0][KX-3])*(pprz[0][KX-1]-pprz[0][KX-3])/DX
//          -0.5*wprz[k+1][KX-2]*(pprz[k+1][KX-2]-pprz[0][KX-2])/DZ
//          +G*rho0[0]*0.5*wprz[0+1][KX-2];
//        dpdt[KLEV-1][1] = 
//          -0.25*(uprz[KLEV-1][1]+uprz[KLEV-1][0])*(pprz[KLEV-1][2]-pprz[KLEV-1][0])/DX
//          -0.5*wprz[KLEV-1][1]*(pprz[KLEV-1][1]-pprz[KLEV-2][1])/DZ
//          +G*rho0[KLEV-1]*0.5*wprz[KLEV-1][1];
//        dpdt[KLEV-1][KX-2] = 
//          -0.25*(uprz[KLEV-1][KX-2]+uprz[KLEV-1][KX-3])*(pprz[KLEV-1][KX-1]-pprz[KLEV-1][KX-3])/DX
//          -0.5* wprz[KLEV-1][KX-2]*(pprz[KLEV-1][KX-2]-pprz[KLEV-2][KX-2])/DZ
//          +G*rho0[KLEV-1]*0.5*wprz[KLEV-1][KX-2];
//        dthdt[0][1] = 
//          -0.25*(uprz[0][1]+uprz[0][0])*(thprz[0][2]-thprz[0][0])/DX
//          -0.5*(wprz[1][1]*(thprz[1][1]-thprz[0][1]))/DZ;
//        dthdt[0][KX-2] = 
//          -0.25*(uprz[0][KX-2]+uprz[0][KX-3])*(thprz[0][KX-1]-thprz[0][KX-3])/DX
//          -0.5*wprz[k+1][KX-2]*(thprz[k+1][KX-2]-thprz[0][KX-2])/DZ;
//        dthdt[KLEV-1][1] = 
//          -0.25*(uprz[KLEV-1][1]+uprz[KLEV-1][0])*(thprz[KLEV-1][2]-thprz[KLEV-1][0])/DX
//          -0.5*wprz[KLEV-1][1]*(thprz[KLEV-1][1]-thprz[KLEV-2][1])/DZ;
//        dthdt[KLEV-1][KX-2] = 
//          -0.25*(uprz[KLEV-1][KX-2]+uprz[KLEV-1][KX-3])*(thprz[KLEV-1][KX-1]-thprz[KLEV-1][KX-3])/DX
//          -0.5* wprz[KLEV-1][KX-2]*(thprz[KLEV-1][KX-2]-thprz[KLEV-2][KX-2])/DZ;
////  for (k = 0; k < KLEV; k++)
////    {
////      dudt[k][0] = dudt[k][1];
////      dudt[k][KX-1] = dudt[k][KX-2];
////      dwdt[k][0] = dwdt[k][1];
////      dwdt[k][KX-1] = dwdt[k][KX-2];
////      dpdt[k][0] = dpdt[k][1];
////      dpdt[k][KX-1] = dpdt[k][KX-2];
////      dthdt[k][0] = dthdt[k][1];
////      dthdt[k][KX-1] = dthdt[k][KX-2];
////    }
//  for (i = 1; i < KX-1; i++)
//    {
//      dudt[0][i] = 
//        -0.25*((uprz[0][i+1]+uprz[0][i])*(uprz[0][i+1]+uprz[0][i])
//        -(uprz[0][i]+uprz[0][i-1])*(uprz[0][i]+uprz[0][i-1]))/DX
//        +0.5*uprz[0][i]*(uprz[0][i+1] - uprz[0][i-1])/DX
//        -0.5*((uprz[1][i]+uprz[0][i])*wprz[1][i])/DZ
//        +uprz[0][i]*(wprz[1][i])/DZ;
//      dudt[KLEV-1][i] = 
//        -0.25*((uprz[KLEV-1][i+1]+uprz[KLEV-1][i])*(uprz[KLEV-1][i+1]+uprz[KLEV-1][i])
//        -(uprz[KLEV-1][i]+uprz[KLEV-1][i-1])*(uprz[KLEV-1][i]+uprz[KLEV-1][i-1]))/DX
//        +0.5*uprz[KLEV-1][i]*(uprz[KLEV-1][i+1] - uprz[KLEV-1][i-1])/DX
//        +0.5*((uprz[KLEV-1][i]+uprz[k-1][i])*wprz[KLEV-1][i])/DZ
//        -uprz[KLEV-1][i]*(wprz[KLEV-1][i])/DZ;
//      dpdt[0][i] = -0.5*(uprz[0][i]*(pprz[0][i+1]+pprz[0][i])
//        -uprz[0][i-1]*(pprz[0][i]+pprz[0][i-1]))/DX
//        +pprz[0][i]*(uprz[0][i] - uprz[0][i-1])/DX
//        -0.5*wprz[1][i]*(pprz[1][i]+pprz[0][i])/DZ
//        +pprz[0][i]*wprz[1][i]/DZ
//        + G*rho0[0]*0.5*(wprz[1][i]);
//      dpdt[KLEV-1][i] = -0.5*(uprz[KLEV-1][i]*(pprz[KLEV-1][i+1]+pprz[KLEV-1][i])
//        -uprz[KLEV-1][i-1]*(pprz[KLEV-1][i]+pprz[KLEV-1][i-1]))/DX
//        +pprz[KLEV-1][i]*(uprz[KLEV-1][i] - uprz[KLEV-1][i-1])/DX
//        +0.5*wprz[KLEV-1][i]*(pprz[KLEV-1][i]+pprz[KLEV-2][i])/DZ
//        -pprz[KLEV-1][i]*wprz[KLEV-1][i]/DZ
//        + G*rho0[KLEV-1]*0.5*(wprz[KLEV-1][i]);
//      dthdt[0][i] = -0.5*(uprz[0][i]*(thprz[0][i+1]+thprz[0][i])
//        -uprz[0][i-1]*(thprz[0][i]+thprz[0][i-1]))/DX
//        +thprz[0][i]*(uprz[0][i] - uprz[0][i-1])/DX
//        -0.5*wprz[1][i]*(thprz[1][i]+thprz[0][i])/DZ
//        +thprz[0][i]*wprz[1][i]/DZ;
//      dthdt[KLEV-1][i] = -0.5*(uprz[KLEV-1][i]*(thprz[KLEV-1][i+1]+thprz[KLEV-1][i])
//        -uprz[KLEV-1][i-1]*(thprz[KLEV-1][i]+thprz[KLEV-1][i-1]))/DX
//        +thprz[KLEV-1][i]*(uprz[KLEV-1][i] - uprz[KLEV-1][i-1])/DX
//        +0.5*wprz[KLEV-1][i]*(thprz[KLEV-1][i]+thprz[KLEV-2][i])/DZ
//        +thprz[KLEV-1][i]*(wprz[KLEV][i] - wprz[KLEV-1][i])/DZ;
//    }
  for (i = 0; i < KX; i++)
    {
      dwdt[0][i] = 0.0;
      dwdt[KLEV][i] = 0.0;
    }
//  dudt[0][0] = 
//    -0.25*((uprz[0][i+1]+uprz[0][0])*(uprz[0][1]+uprz[0][0])
//    -(uprz[0][0]+uprz[0][KX-1])*(uprz[0][0]+uprz[0][KX-1]))/DX
//    +0.5*uprz[0][0]*(uprz[0][1] - uprz[0][KX-1])/DX
//    -0.5*((uprz[1][0]+uprz[0][0])*wprz[1][0])/DZ
//    +uprz[0][0]*(wprz[1][0])/DZ;
//  dudt[KLEV-1][0] = 
//    -0.25*((uprz[KLEV-1][1]+uprz[KLEV-1][0])*(uprz[KLEV-1][1]+uprz[KLEV-1][0])
//    -(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])*(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1]))/DX
//    +0.5*uprz[KLEV-1][0]*(uprz[KLEV-1][1] - uprz[KLEV-1][KX-1])/DX
//    +0.5*((uprz[KLEV-1][0]+uprz[k-1][0])*wprz[KLEV-1][0])/DZ
//    -uprz[KLEV-1][0]*(wprz[KLEV-1][0])/DZ;
//  dudt[0][KX-1] = 
//    -0.25*((uprz[0][0]+uprz[0][KX-1])*(uprz[0][0]+uprz[0][KX-1])
//    -(uprz[0][KX-1]+uprz[0][KX-2])*(uprz[0][KX-1]+uprz[0][KX-2]))/DX
//    +0.5*uprz[0][KX-1]*(uprz[0][0] - uprz[0][KX-2])/DX
//    -0.5*((uprz[1][KX-1]+uprz[0][KX-1])*wprz[1][KX-1])/DZ
//    +uprz[0][KX-1]*(wprz[1][KX-1])/DZ;
//  dudt[KLEV-1][KX-1] = 
//    -0.25*((uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])*(uprz[KLEV-1][0]+uprz[KLEV-1][KX-1])
//    -(uprz[KLEV-1][KX-1]+uprz[KLEV-1][KX-2])*(uprz[KLEV-1][KX-1]+uprz[KLEV-1][KX-2]))/DX
//    +0.5*uprz[KLEV-1][KX-1]*(uprz[KLEV-1][0] - uprz[KLEV-1][KX-2])/DX
//    +0.5*((uprz[KLEV-1][KX-1]+uprz[k-1][KX-1])*wprz[KLEV-1][KX-1])/DZ
//    -uprz[KLEV-1][KX-1]*(wprz[KLEV-1][KX-1])/DZ;
//  dpdt[0][0] = -0.5*(uprz[0][0]*(pprz[0][1]+pprz[0][0])
//    -uprz[0][KX-1]*(pprz[0][0]+pprz[0][KX-1]))/DX
//    +pprz[0][0]*(uprz[0][0] - uprz[0][KX-1])/DX
//    -0.5*wprz[1][0]*(pprz[1][0]+pprz[0][0])/DZ
//    +pprz[0][i]*wprz[1][i]/DZ
//    + G*rho0[0]*0.5*(wprz[1][0]);
//  dpdt[KLEV-1][0] = -0.5*(uprz[KLEV-1][0]*(pprz[KLEV-1][1]+pprz[KLEV-1][0])
//    -uprz[KLEV-1][KX-1]*(pprz[KLEV-1][0]+pprz[KLEV-1][KX-1]))/DX
//    +pprz[KLEV-1][0]*(uprz[KLEV-1][0] - uprz[KLEV-1][KX-1])/DX
//    +0.5*wprz[KLEV-1][0]*(pprz[KLEV-1][0]+pprz[KLEV-2][0])/DZ
//    +pprz[KLEV-1][0]*(wprz[KLEV][0] - wprz[KLEV-1][0])/DZ
//    + G*rho0[KLEV-1]*0.5*(wprz[KLEV-1][0]);
//  dpdt[0][KX-1] = -0.5*(uprz[0][KX-1]*(pprz[0][0]+pprz[0][KX-1])
//    -uprz[0][KX-2]*(pprz[0][KX-1]+pprz[0][KX-2]))/DX
//    +pprz[0][KX-1]*(uprz[0][KX-1] - uprz[0][KX-2])/DX
//    -0.5*wprz[1][KX-1]*(pprz[1][KX-1]+pprz[0][KX-1])/DZ
//    +pprz[0][KX-1]*wprz[1][KX-1]/DZ
//    + G*rho0[0]*0.5*(wprz[1][KX-1]);
//  dpdt[KLEV-1][KX-1] = -0.5*(uprz[KLEV-1][KX-1]*(pprz[KLEV-1][0]+pprz[KLEV-1][KX-1])
//    -uprz[KLEV-1][KX-2]*(pprz[KLEV-1][KX-1]+pprz[KLEV-1][KX-2]))/DX
//    +pprz[KLEV-1][KX-1]*(uprz[KLEV-1][KX-1] - uprz[KLEV-1][KX-2])/DX
//    +0.5*wprz[KLEV-1][KX-1]*(pprz[KLEV-1][KX-1]+pprz[KLEV-2][KX-1])/DZ
//    +pprz[KLEV-1][KX-1]*(wprz[KLEV][KX-1] - wprz[KLEV-1][KX-1])/DZ
//    + G*rho0[KLEV-1]*0.5*(wprz[KLEV-1][KX-1]);
//  dthdt[0][0] = -0.5*(uprz[0][0]*(thprz[0][1]+thprz[0][0])
//    -uprz[0][KX-1]*(thprz[0][0]+thprz[0][KX-1]))/DX
//    +thprz[0][0]*(uprz[0][0] - uprz[0][KX-1])/DX
//    -0.5*wprz[1][0]*(thprz[1][0]+thprz[0][0])/DZ
//    +thprz[0][i]*wprz[1][i]/DZ;
//  dthdt[KLEV-1][0] = -0.5*(uprz[KLEV-1][0]*(thprz[KLEV-1][1]+thprz[KLEV-1][0])
//    -uprz[KLEV-1][KX-1]*(thprz[KLEV-1][0]+thprz[KLEV-1][KX-1]))/DX
//    +thprz[KLEV-1][0]*(uprz[KLEV-1][0] - uprz[KLEV-1][KX-1])/DX
//    +0.5*wprz[KLEV-1][0]*(thprz[KLEV-1][0]+thprz[KLEV-2][0])/DZ
//    +thprz[KLEV-1][0]*(wprz[KLEV][0] - wprz[KLEV-1][0])/DZ;
//  dthdt[0][KX-1] = -0.5*(uprz[0][KX-1]*(thprz[0][0]+thprz[0][KX-1])
//    -uprz[0][KX-2]*(thprz[0][KX-1]+thprz[0][KX-2]))/DX
//    +thprz[0][KX-1]*(uprz[0][KX-1] - uprz[0][KX-2])/DX
//    -0.5*wprz[1][KX-1]*(thprz[1][KX-1]+thprz[0][KX-1])/DZ
//    +thprz[0][KX-1]*wprz[1][KX-1]/DZ;
//  dthdt[KLEV-1][KX-1] = -0.5*(uprz[KLEV-1][KX-1]*(thprz[KLEV-1][0]+thprz[KLEV-1][KX-1])
//    -uprz[KLEV-1][KX-2]*(thprz[KLEV-1][KX-1]+thprz[KLEV-1][KX-2]))/DX
//    +thprz[KLEV-1][KX-1]*(uprz[KLEV-1][KX-1] - uprz[KLEV-1][KX-2])/DX
//    +0.5*wprz[KLEV-1][KX-1]*(thprz[KLEV-1][KX-1]+thprz[KLEV-2][KX-1])/DZ
//    +thprz[KLEV-1][KX-1]*(wprz[KLEV][KX-1] - wprz[KLEV-1][KX-1])/DZ;
  return 0;
}
